#ifndef HARDWARE_H
#define HARDWARE_H

// Sender-Ausgang freigeben
#define TXHI (DDRB |= (1 << PB1))
#define TXLO (DDRB &= ~(1 << PB1))

#define RXHI (PORTD |= (1 << PD4))
#define RXLO (PORTD &= ~(1 << PD4))
/*
#define DIM1 1
#define DIM2 2
#define DIM3 4
#define DIM4 4
#define KEY1 16
#define KEY2 32
#define KEY3 64
#define KEY4 128*/


// ersten 4 CFG's enthalten momentane Helligkeit

#define CFGSIZE 16
unsigned char volatile cfg[CFGSIZE];

#define setup	 	(cfg[4])
#define fallback 	(cfg[5])
#define grundoffset (cfg[6])
#define tastdown    (cfg[7])

// Wert zu dem hin gedimmt werden soll
#define dim_to  	(&cfg[8])
#define dim_time    (&cfg[12])

unsigned char dim_cnt[4]; // Zhler fr "hindimmen"


unsigned char wait_1ms;  // Gibt den Queuehandler frei, um neue Daten zu verschicken

void init_hardware(void);

#include <avr/io.h>
#include "keyhandler.h"
#define uart_rx_off() UCSRB &= ~(1 << RXEN)
#define uart_rx_on()  UCSRB |= (1 << RXEN); loop_until_bit_is_set(UCSRA, UDRE)
#define uart_send_byte(b)  loop_until_bit_is_set(UCSRA, UDRE); outp(b, UDR)

#define uart_rx_on()  UCSRB |= (1 << RXEN); while(!(UCSRA & (1 << UDRE))) keyhandler()
#define uart_send_byte(b)  while(!(UCSRA & (1 << UDRE))) keyhandler(); outp(b, UDR)



#endif
