#include <avr/io.h>
#include "main.h"
#include "keyhandler.h"
#include "hardware.h"
#include "register.h";
#include "protocol.h";

unsigned char entprell[4];
unsigned char keydelay[4];


#define SHORTPRESS (300 / KEYUPDPERIOD)
#define LONGPRESS  (500 / KEYUPDPERIOD)
#define INCDELAY   (32   / KEYUPDPERIOD)

/*******************************************************************
 * Wenn der AVR nichts zu tun hat, werden Tasten abgefragt
 * Normale Taster gehen gegen GND, d.H. wird eine Taste gedrckt,
 * geht das Bit gegen 0
 * Direkteingnge: ber 2x 1 MOhm:
 * Liegt Phase an, so ist das Bit 1,
 * Liegt Nulleiter an, so toggled der Ausgang hin und her.
 *******************************************************************/
void keyhandler() { // ca 118 Byte
	static unsigned char i;
	static unsigned char was_on;
	static unsigned char dim_dir;
	unsigned char register eptmp;
	unsigned char register cfgtmp;
	unsigned char register key;
	unsigned char r =  (KEY_IN >> 2) ^ CFG_KEYXOR;  // Port mit den Tastern, 0 = gedrckt !!
 	i++;
	i &= 0x03;
	key= 2 << i;
	if (i == 3) key = 1; // Sondertaste an SS

	
	
	eptmp=entprell[i]; // jetzt nur noch mit Registern arbeiten
	cfgtmp=cfg[i];
	if (r & key ) { // aktuelle Taste mit Maske abfragen
		// Taste i nicht gedrckt, oder der Ausgang toggled hin und her
		if (eptmp > 8) {
			eptmp-= 8;
			eptmp &= 0xF8;
		} else { // key released
			eptmp=0;
			if ( tastdown & key) {
				if ( tastdown & (key << 4)) {
					dim_dir ^= key;
					send_event(EVENT_RELEASELONG | i);
				} else {
					if (was_on & key) cfgtmp  &=  0x7F;
					send_event(EVENT_RELEASE | i);
				}
				keydelay[i]=0;
				tastdown &= ~(key << 4);
				tastdown &= ~key;
			}
		}
		
	} else {
		
		// Taste gedrckt
		if (eptmp >= 200) {
			if (!(tastdown & key)) {
				if (cfgtmp >= 0x80) {
					was_on |= key; // war an, wir mssen abschalten
				} else {
					was_on &= ~key; // nicht an wir schalten ein
					cfgtmp |= 0x80; 
				}

				tastdown |= key;
				send_event( EVENT_PRESS | i);
			}
		}

		// taste i gedrckt
		if (eptmp < 250) eptmp++; // geschlossen/offen kann 1:4 sein
		
		if (keydelay[i] > LONGPRESS) { // Taste wurde lang gedrckt
			if (!(tastdown & (key << 4) )) {
				tastdown |= (key << 4);
				send_event( EVENT_PRESSLONG | i);
			}
			
			keydelay[i] -= INCDELAY; // nchsten langen Tastendruck um INCDELAY verzgern
			if (cfgtmp < 0x80) dim_dir |= key; // bei lampe aus erst mal aufwrts dimmen
			cfgtmp |= 0x80; // auf alle Flle einschalten
			if (dim_dir & key ) {
				if (cfgtmp < 0xFF) cfgtmp++;
			} else {
				if (cfgtmp > 0x80) cfgtmp--;
			}

		}
	}

	entprell[i]=eptmp;
	if (setup & key) {  // mit Taster verbunden
		if (setup & key << 4) {  // normaler Ausgang, welcher nur HL sein kann
			if (cfgtmp < 128) cfgtmp = 0; else cfgtmp = 255;
		}

		cfg[i]=cfgtmp;
	}
}

// Routine zum Erkennen wann eine Taste lang gedrckt wird, Aufruf alle 10 ms
void updatekeydelays() {
	unsigned char i;
	for(i=0; i < 4; i++) {
		if (entprell[i] > 200) {
			if (keydelay[i] < 255) keydelay[i]++;
		}
	}
}
