#ifndef MAIN_H
#define MAIN_H
#include <inttypes.h>
#define sbi(ADDRESS,BIT) ((ADDRESS) |= (1<<(BIT)))
#define cbi(ADDRESS,BIT) ((ADDRESS) &= ~(1<<(BIT)))
#define outp(VAL,ADRESS) ((ADRESS) = (VAL))
#define inp(VAL) (VAL)
#define BV(VAL) (1 << VAL)

// 125 Khz
#define CFG_TXHF	(4000 / 125) / 2
#define CFG_CHAN0		127
#define CFG_CHAN1		127
#define CFG_CHAN2		127
#define CFG_CHAN3		127
#define CFG_THRESHOLD 	20
#define CFG_SETUP 		0x0F
#define CFG_FALLBACK 	0x0F
#define CFG_PWM			0
#define CFG_OFFSET		75
#define CFG_KEYXOR			0
#define NEG_HW

//#define BRIDGE_MODUL
//#define RGB_MODUL
#define DIM_MODUL
/***************************/
#ifdef RGB_MODUL

#define CFG_PWM 2
#define DEV_ID 69

#endif

/***************************/
#ifdef BRIDGE_MODUL

#define CFG_PWM	2
#undef NEG_HW
#define INT1_TXCTL
#define DEV_ID 79
#define CFG_SETUP 		0
#define CFG_FALLBACK 	0

#endif
/***************************/
#ifdef DIM_MODUL

#define DEV_ID 17
// Taster an 2+3
#define CFG_SETUP 		0x06
#define CFG_FALLBACK 	0x06

//2* 1 MOhm an 1+4
#define CFG_KEYXOR 		0x09

#endif



// Events (nur bits 4..7 verwenden)
#define EVENT_DIMFINISH 	(1 << 4)
#define EVENT_PRESS 		(2 << 4)
#define EVENT_PRESSLONG		(3 << 4)
#define EVENT_RELEASE 		(4 << 4)
#define EVENT_RELEASELONG 	(5 << 4)
#define EVENT_POWERON 		(6 << 4)

//void inline keyhandler(unsigned char i);

// #define DEBUGBOARD


#ifdef DEBUGBOARD

#define POWER_PORT PORTB
#define POWER_DDR  DDRB
#define KEY_IN     PIND
#define KEY_PORT   PORTD
#define KEY_DDR    DDRD

#else

#define POWER_PORT PORTC
#define POWER_DDR  DDRC
#define KEY_IN     PINB
#define KEY_PORT   PORTB
#define KEY_DDR    DDRB

#endif // debugboard

#endif // main.h

