#include <sys/types.h>
#include <sys/stat.h>
#include <sys/signal.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <sys/time.h>
#include <signal.h>
#include "protocol.h"
  
#define BAUDRATE B1200
#define MODEMDEVICE "/dev/ttyS0"
#define _POSIX_SOURCE 1 /* POSIX compliant source */
#define FALSE 0
#define TRUE 1
  
volatile int STOP=FALSE; 
void signal_handler_IO (int status);
void age_sendq(void);
void send_from_queue(void);

int fd; 

void inittty() {
  struct termios oldtio,newtio;
  struct sigaction saio; 

  fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY ); 
  if (fd <0) {perror(MODEMDEVICE); exit(-1); }
 
  saio.sa_handler = signal_handler_IO;
  //saio.sa_mask = 0;
  saio.sa_flags = 0;
  saio.sa_restorer = NULL;
  sigaction(SIGIO,&saio,NULL);

  fcntl(fd, F_SETOWN, getpid());					 
  fcntl(fd, F_SETFL, FASYNC);
  
  tcgetattr(fd,&oldtio); /* save current port settings */
  
  bzero(&newtio, sizeof(newtio));
  newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
  newtio.c_iflag = IGNPAR;
  newtio.c_oflag = 0;
  
  /* set input mode (non-canonical, no echo,...) */
  newtio.c_lflag = 0;
   
  newtio.c_cc[VTIME]    = 0;   /* inter-character timer unused */
  newtio.c_cc[VMIN]     = 1;   /* blocking read until 5 chars received */
  
  tcflush(fd, TCIFLUSH);
  tcsetattr(fd,TCSANOW,&newtio);
//  for (;;) uart_send_byte(0x00);
}



void catcher( int sig ) {

    queuetimer();

}
		
		
void inittimer() {

    struct itimerval value, ovalue;
    int result;
    int which = ITIMER_REAL;

    struct sigaction sact;

    sigemptyset( &sact.sa_mask );
    sact.sa_flags = 0;
    sact.sa_handler = catcher;
    sigaction( SIGALRM, &sact, NULL );
		
    value.it_interval.tv_sec = 0;        /* Zero seconds */
    value.it_interval.tv_usec = 20000;  /* Two hundred milliseconds */
    value.it_value.tv_sec = 0;           /* Zero seconds */
    value.it_value.tv_usec = 500000;     /* Five hundred milliseconds */
		
    result = setitimer( which, &value, &ovalue );
		    
}

int main()
{
  inittty();
  inittimer();
  startserver(2345);
  //enqueuepacket("Test",4,1);
  while (STOP==FALSE) {       /* loop for input */
//    res = read(fd,buf,255);   /* returns after 5 chars have been input */
//    buf[res]=0;               /* so we can printf... */
//    printf(":%s:%d\n", buf, res);
    //if (buf[0]=='z') STOP=TRUE;
    //usleep(1000000);
    //sleep(3);
    //printf("Sende\n");
    //
    //age_sendq();
    //send_from_queue();
  }
  //tcsetattr(fd,TCSANOW,&oldtio);
  return 0;
}


#define MODULE_ID 'M'


void uart_send_byte(unsigned char b) {
    //printf("Send %c ",b);
    write(fd,&b,1); 
    //fflush(stdout);
} 


unsigned char len;
unsigned char crc;
unsigned char pos;
unsigned char rcvbuf[17];



void signal_handler_IO (int status)
{
    unsigned char buf[255];
    int i,res;
    //printf("received SIGIO signal.\n");
    res = read(fd,buf,255);   /* returns after 5 chars have been input */
    buf[res]=0;               /* so we can printf... */
    if (buf[0] >=32 && buf[0] <= 128) {
	//printf("%c", buf[0]);
    } else {
	//printf(".");
    }
    fflush(stdout);
    for (i = 0; i < res; i++) uart_receive_byte(buf[i]);
}    
