/* A simple server in the internet domain using TCP
   The port number is passed as an argument */
#include <stdio.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdarg.h>
#include <protocol.h>
void Reply(int *sock, int Code, const char *fmt, ...);

void error(char *msg)
{
    perror(msg);
    exit(1);
}

char *skipspace(const char *s)
{
    while (*s && isspace(*s))
          s++;
    return (char *)s;
}	    
void CmdTALK(int *sock, char *c) {
    int i;
    unsigned char answer[16];
    i=talk('T',c, strlen(c));
    if (i != 255) {
	Reply(sock,200,"Module not reached");
    } else {
	i=getanswer(answer);
	answer[i]=0;
	Reply(sock,200,"Module answered: %s",answer);
    }
}

void CmdSEND(int *sock, char *c) {
    char *module, *s, *v; // Modul, speicherstelle, Wert
    int i;
    unsigned char answer[16];
    unsigned char moduleID;
    unsigned char send[16];

    module = skipspace(c);
    // find the end of the command word:
    s = module; 
    while (*s && !isspace(*s))
	    s++;
    if (*s)
	*s++ = 0; 

    s = skipspace(s);

    v = s;
    while (*v && !isspace(*v))
	    v++;
    if (*v)
	*v++ = 0; 
    	
    v = skipspace(v);

    if (*module && *s && *v) {
	moduleID=strtol(module, NULL, 10);
	send[0]='s';
	send[1]=strtol(s, NULL, 10);
	send[2]=strtol(v, NULL, 10);
	i=talk(moduleID, send, 3);
    if (i != 255) {
	Reply(sock,200,"Module %c not reached",moduleID);
    } else {
	i=getanswer(answer);
	answer[i]=0;
	Reply(sock,200,"Module answered: %s",answer);
    }
	Reply(sock,200,"Send ok");
    } else {
	Reply(sock, 501,"Syntax error: SEND <moduleID> <mem> <value>");
    }
/*    int i;
    unsigned char answer[16];
    i=talk('T',c, strlen(c));
    if (i != 255) {
	Reply(sock,200,"Module not reached");
    } else {
	i=getanswer(answer);
	answer[i]=0;
	Reply(sock,200,"Module answered: %s",answer);
    }
*/
}
void CmdCTXT(int *sock, char *c) {
    enqueuepacket(c, strlen(c),0);
    //sendctl=240;
}

void CmdQUIT(int *sock, char *c) {
    Reply(sock,100,"Goodbye");
    close(*sock);
    *sock = 0;
}

void Reply(int *sock, int Code, const char *fmt, ...) {
    char *buffer;
    if (*sock) {
	if (Code != 0) {
    	    va_list ap;
	    va_start(ap, fmt);
	    vasprintf(&buffer, fmt, ap);
	    char *nl = strchr(buffer, '\n');
	    if (Code > 0 && nl && *(nl + 1)) // trailing newlines don't count!
	    Code = -Code;
	    char number[16];
	    sprintf(number, "%03d%c", abs(Code), Code < 0 ? '-' : ' ');
	    const char *s = buffer;
	    while (s && *s) {
		const char *n = strchr(s, '\n');
		if (!( write(*sock,number, strlen(number))
		    && write(*sock,s, n ? n - s : strlen(s)) 
		    && write(*sock,"\r\n",2))) {
		    close(*sock);
		    *sock = 0;
		    break;
		}
		s = n ? n + 1 : NULL;
	    }
	    free(buffer);
	    va_end(ap);
	}
	else {
	    Reply(sock, 451, "Zero return code - looks like a programming error!");
	 }
    }
	       
}

#define CMD(c) (strcasecmp(Cmd, c) == 0)

void execute(int *sock, char *Cmd) {
    char *s;
    Cmd = skipspace(Cmd);
    // find the end of the command word:
    s = Cmd;
    while (*s && !isspace(*s))
	    s++;
    if (*s)
	*s++ = 0;
    s = skipspace(s);
    if 	    (CMD("TALK"))  CmdTALK(sock,s);
    else if (CMD("CTXT"))  CmdCTXT(sock,s);
    else if (CMD("SEND"))  CmdSEND(sock,s);
    else if (CMD("QUIT"))  CmdQUIT(sock,s);
    else                   Reply(sock, 500, "Command unrecognized: \"%s\"", Cmd);
}      	
		  
void dostuff (int *sock)
{
    int r;
    char c;
    char buffer[256];
    int numChars;
    char cmdLine[32];
    bzero(buffer,256);
    numChars = 0;
    Reply(sock, 500, "Welcome to the pram's homenode server");
    while (*sock) {
	r = read(*sock,&c,1); // read one char
	if (r > 0) {
    	    if (c == '\n' || c == 0x00) {
	        // strip trailing whitespace:
		while (numChars > 0 && strchr(" \t\r\n", cmdLine[numChars - 1]))
                       cmdLine[--numChars] = 0;
                // make sure the string is terminated:
		cmdLine[numChars] = 0;
		// showtime!
		execute(sock,cmdLine);
                numChars = 0;
		}
            else if (c == 0x04 && numChars == 0) {
	        // end of file (only at beginning of line)
		close(*sock);
		*sock = 0;
                }
            else if (c <= 0x03 || c == 0x0D) {
		// ignore control characters
		}
	    else if (numChars < sizeof(cmdLine) - 1) {
		cmdLine[numChars++] = c;
                cmdLine[numChars] = 0;
		}
	    else {
		Reply(sock, 501, "Command line too long");
		}
	}
    }
}
			
int startserver(int portno)
{
    int sockfd, newsockfd, clilen;
    char buffer[256];
    struct sockaddr_in serv_addr, cli_addr;
    int n;
    int pid;
    sockfd = socket(AF_INET, SOCK_STREAM, 0);

    if (sockfd < 0) 
        error("ERROR opening socket");
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = INADDR_ANY;
    serv_addr.sin_port = htons(portno);
    if (bind(sockfd, (struct sockaddr *) &serv_addr,
              sizeof(serv_addr)) < 0) 
              error("ERROR on binding");
    listen(sockfd,5);
    clilen = sizeof(cli_addr);
    while(1) {
	newsockfd = accept(sockfd, 
                 (struct sockaddr *) &cli_addr, 
                 &clilen);
	if (newsockfd > 0) dostuff(&newsockfd);
    }		  
    return 0; 
}
			
