<?

function parsestr($str) {
    $tokens=array();
    $tok = strtok($str, " ");
    while ($tok !== false) {
	array_push($tokens, $tok);
	$tok = strtok(" \n\t");
    }
    return $tokens;
}

# Transmit function
function tx ($string) {
    $fp = fsockopen("localhost", 2346, $errno, $errstr, 10);
    if (!$fp) {
	echo "$errstr ($errno)<br />\n";
	return false;
    } 
    echo "[TX] $string\n";
    fwrite($fp, "$string\n");
    $str="";
    while (!feof($fp)) {
	$str.= fgets($fp, 128);
    }
    echo "[info] $str\n";
    $result=parsestr($str);
    if ($result[0] >= 500) $result[1]=$str;
    fclose($fp);
    return $result;
}

# query <modul> <mem>
function query ($ID, $mem) {
    $ret=tx("query $ID $mem");
    if ($ret == false) return false;
    if ($ret[0] != 201) {
	echo "[Error] query: $ret[1]\n";
	return false;
    }
    return $ret[1];
}

function burst ($ID, $dump) {
    $ret=tx("burst $ID $dump[0] $dump[1] $dump[2] $dump[3]");
    if ($ret == false) return false;
    if ($ret[0] != 201) {
	echo "[Error] burst: $ret[1]\n";
	return false;
    }
    return $ret[1];
}

function config ($ID) {
    $ret=tx("config $ID");
    if ($ret == false) return false;
    if ($ret[0] != 202) {
	echo "[Error] config: $ret[1]\n";
	return false;
    }
    return array($ret[1], $ret[2], $ret[3], $ret[4], $ret[5], $ret[6], $ret[7], $ret[8]);
}


function set ($ID, $mem, $value) {
    $ret=tx("set $ID $mem $value");
    if ($ret == false) return false;
    if ($ret[0] != 200) {
	echo "[Error] set: $ret[1]\n";
	return false;
    }
    return true;
}

function pulse ($ID, $chan) {
    $ret=tx("pulse $ID $chan 3");
    if ($ret == false) return false;
    if ($ret[0] != 200) {
	echo "[Error] pulse: $ret[1]\n";
	return false;
    }
    return true;
}

function toggle ($ID, $chan) {
    $ret=tx("toggle $ID $chan");
    if ($ret == false) return false;
    if ($ret[0] != 200) {
	echo "[Error] pulse: $ret[1]\n";
	return false;
    }
    return true;
}

function dim($ID, $chan, $updown) {
    $val=query($ID,$chan);
    if ($val == false) die("[Error] on dim\n");
    $val=$val + ($val/255)*$updown;
    $val=round($val);
    if ($val > 255) $val=255;
    if ($val < 127) $val=127;
    set($ID, $chan, $val);
}




?>