#!/usr/bin/php-cgi
<?

include "basefunctions.php";
//$cmd=strr
//$cmd=preg_replace("/[^a-z]/i","",$argv[0]);
function getrgb() {
    $cfg=config(69);
    if ($cfg == false) die();
    return array($cfg[0],$cfg[1],$cfg[2]);
}

function setrgb($rgb) {
    $cfg=burst(69, $rgb);
}

function off() {
    $rgb=getrgb();
    $rgb[0] &= 0x7F;
    $rgb[1] &= 0x7F;
    $rgb[2] &= 0x7F;
    setrgb($rgb);
}

function on() {
    $rgb=getrgb();
    $rgb[0] |= 0x80;
    $rgb[1] |= 0x80;
    $rgb[2] |= 0x80;
    setrgb($rgb);
}

function rgbtoggle() {
    $rgb=getrgb();
    print_r($rgb);
    if (max($rgb[0],$rgb[1],$rgb[2]) < 128) {
	$rgb[0] |= 0x80;
	$rgb[1] |= 0x80;
	$rgb[2] |= 0x80;
    } else {
	$rgb[0] &= 0x7F;
	$rgb[1] &= 0x7F;
	$rgb[2] &= 0x7F;
    }

    print_r($rgb);

    setrgb($rgb);
}

function decode($i) {
    $i = $i - 127;
    $i = $i + $i; // ($i*$i)/128;
    return $i;
}
function encode($i) {
    $i = $i / 2;
    $i = $i + 127;
    if ($i < 128) return 128;
    if ($i > 255) return 255;
    return round($i);
}

function RGBtoHSB($red, $green, $blue)
{
	// Daten verifizieren
	$data = array("Red"=>$red, "Green"=>$green, "Blue"=>$blue);
	foreach($data as $index=>$wert)
	{
		settype($data[$index], "integer");
		if($data[$index]<0) $data[$index]=0;
		if($data[$index]>255) $data[$index]=255;
	}
	$rgb = $data;
	// Sonderfall: Grau
	if($data["Red"]==$data["Green"] && $data["Green"]==$data["Blue"])
	{
		return array("Hue"=>0, "Saturation"=>0, "Brightness"=>round(100/255*$data["Red"]));
	}

	// Berechnung der Daten
	$max = max($data["Red"], $data["Green"], $data["Blue"]);
	$min = min($data["Red"], $data["Green"], $data["Blue"]);
	$saturation = ($max - $min) / $max;
	$brightness = $max / 255;

	$max_index = array_search($max, $rgb); // Farbe von Max
	$farben = array("Red"=>0, "Green"=>1, "Blue"=>2);
	$hue = (($farben[$max_index] * 120) + 360); // Grundwert der Maximum-Farbe (in Grad)
	// Max und Min aus Arbeits-Array entfernen, damit mittlerer Wert brig bleibt
	unset($rgb[$max_index]);
	unset($rgb[array_search($min, $rgb)]);
	// Berechnung der Abweichung vom Grundwert mittels dem Mittleren Wert
	$hue2 = (  (1 - ($max - reset($rgb)) / ($max - $min) ) * 60 );
	// Entweder Abweichung addieren oder abziehen
	if(($farben[$max_index]+1)%3 == $farben[key($rgb)]) $hue += $hue2;
	else $hue -= $hue2;
	// Modulo
	$hue %=360;

	return array("Hue"=>(int)round($hue), "Saturation"=>(int)round($saturation*100), "Brightness"=>(int)round($brightness*100));
}


function HSBtoRGB($hue, $saturation, $brightness)
{
	// Daten verifizieren
	settype($hue, "integer");
	settype($saturation, "integer");
	settype($brightness, "integer");
	if($hue <   0) $hue +=360 ;
//	if($hue > 360) $hue = 360;
	$hue = $hue % 360;
	if($saturation <   0) $saturation =   0;
	if($saturation > 100) $saturation = 100;
	if($brightness <   0) $brightness =   0;
	if($brightness > 100) $brightness = 100;

	// Hue
	$rgb = array("Red" => abs($hue - 180), "Green" => 180 - abs($hue - 120), "Blue" => 180 - abs($hue - 240));
	foreach($rgb as $farbe=>$farbwert)
	{
		if($rgb[$farbe] <  60) $rgb[$farbe] =  60;
		if($rgb[$farbe] > 120) $rgb[$farbe] = 120;
		$rgb[$farbe] -= 60;
		$rgb[$farbe] = 255 / 60 * $rgb[$farbe];
	}
	// Saturation
	foreach($rgb as $farbe=>$farbwert)
	{
		$rgb[$farbe] += (255 - $rgb[$farbe]) / 100 * (100-$saturation);
		$rgb[$farbe] -= $rgb[$farbe] / 100 * (100-$brightness);
		$rgb[$farbe] = ceil(round($rgb[$farbe],2));
	}
	return $rgb;
}


function hsbadj($h=0,$s=0,$b=0) {
    $rgb=getrgb();
    print_r($rgb);
    $hsb=RGBtoHSB(decode($rgb[0]),decode($rgb[1]),decode($rgb[2]));
    print_r($hsb);
    $rgb=HSBtoRGB($hsb[Hue]+$h,$hsb[Saturation]+$s,$hsb[Brightness]+$b);
    $rgb[0]=encode($rgb[Red]);
    $rgb[1]=encode($rgb[Green]);
    $rgb[2]=encode($rgb[Blue]);
    print_r($rgb);
    setrgb($rgb);


}
$cmd=$argv[1];
switch ($cmd) {
    case "off":
	off();
    break;
    case "on":
	on();
    break;
    case "toggle":
	rgbtoggle();
    break;

    case "rgb":
	setrgb(array(encode($argv[2]),encode($argv[3]),encode($argv[4])));
    break;
    case "b+":
	hsbadj(0,0,10);
    break;
    case "b-":
	hsbadj(0,0,-10);
    break;

    case "h+":
	hsbadj(15,0,0);
    break;
    case "h-":
	hsbadj(-15,0,0);
    break;
    
    case "s+":
	hsbadj(0,20,0);
    break;
    case "s-":
	hsbadj(0,-20,0);
    break;

    default:
	echo "[error] not implemented: $cmd\n";
}
?>