/* A simple server in the internet domain using TCP
   The port number is passed as an argument */
#include <stdio.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdarg.h>
#include <protocol.h>
#include <pthread.h>
void Reply(int *sock, int Code, const char *fmt, ...);

void error(char *msg)
{
    perror(msg);
    exit(1);
}

char *skipspace(const char *s)
{
    while (*s && isspace(*s))
          s++;
    return (char *)s;
}	    

void Reply(int *sock, int Code, const char *fmt, ...) {
    char *buffer;
    if (*sock) {
	if (Code != 0) {
    	    va_list ap;
	    va_start(ap, fmt);
	    vasprintf(&buffer, fmt, ap);
	    
	    char *nl = strchr(buffer, '\n');
	    if (Code > 0 && nl && *(nl + 1)) // trailing newlines don't count!
		Code = -Code;
	    char number[16];
	    sprintf(number, "%03d%c", abs(Code), Code < 0 ? '-' : ' ');
	    const char *s = buffer;
	    while (s && *s) {
		const char *n = strchr(s, '\n');
		if (!( write(*sock,number, strlen(number))
		    && write(*sock,s, n ? n - s : strlen(s)) 
		    && write(*sock,"\r\n",2))) {
		    close(*sock);
		    *sock = 0;
		    break;
		}
		s = n ? n + 1 : NULL;
	    }
	    free(buffer);
	    va_end(ap);
	}
	else {
	    Reply(sock, 451, "Zero return code - looks like a programming error!");
	 }
    }
	       
}

/* TCP-IP Verbundung abhandeln */
void execute(int *sock, char *Cmd) {
    unsigned char send[16];
    unsigned char answer[16];
    unsigned char moduleID;
    char *tokens[16];
    int cnt,i;
    cnt=0;
    tokens[cnt++]=strtok(Cmd," ,=");
    while ( ( tokens[cnt] = strtok(NULL," ,=")) && cnt < 16) cnt++;

    if (cnt < 2) {
    	Reply(sock,501,"too few params, you need at least <cmd> <ID>");
	goto out;
    }
    // damit es intuitiver wird zuerst das Kommando:
    send[0]=*tokens[0];
    // dann die ModulID
    moduleID=atoi(tokens[1]);

    // restl Daten fr Modul
    
    // Debug Ausgabe
    printf("[tcp/ip] Sending Cmd %c to Module %d Payload: \n" , send[0], moduleID);
    for (i = 2; i < cnt; i++) {
	send[i-1]=atoi(tokens[i]);
	printf(" %d", send[i-1]);
    }
    printf("\n");
    
    i=talk(moduleID, send, cnt-1); // talk to the PLM-Bus
    
    if (i != 255)  { 
    	Reply(sock,500,"Module timed out");
    } else {
        i=getanswer(answer);
	answer[i]=0;
	switch (answer[0]) {
	    case '!':
		Reply(sock,200,"OK");
		break;
	    case '?':
		Reply(sock,501,"unknown command");
		break;

	    case '=':
		Reply(sock,201," %d",answer[1]);
		break;

	    case ':':
		Reply(sock,202,"%d %d %d %d %d %d %d %d",
		    answer[1],answer[2],answer[3],answer[4],
		    answer[5],answer[6],answer[7],answer[8]);
		break;
	    default:
	    	Reply(sock,502,"unknown module answer");
		break;

	}
	
    }
    // close connectin
out:
    close(*sock);
    *sock = 0;

}      	
		  
void dostuff (int *sock)
{
    int r;
    char c;
    char buffer[256];
    int numChars;
    char cmdLine[32];
    bzero(buffer,256);
    numChars = 0;
    //Reply(sock, 500, "Welcome to the pram's homenode server");
    while (*sock) {
	r = read(*sock,&c,1); // read one char
	if (r > 0) {
	//printf("Read %d\n",r);
    	    if (c == '\n' || c == 0x00) {
	        // strip trailing whitespace:
		while (numChars > 0 && strchr(" \t\r\n", cmdLine[numChars - 1]))
                       cmdLine[--numChars] = 0;
                // make sure the string is terminated:
		cmdLine[numChars] = 0;
		// showtime!
		execute(sock,cmdLine);
                numChars = 0;
		}
            else if (c == 0x04 && numChars == 0) {
	        // end of file (only at beginning of line)
		close(*sock);
		*sock = 0;
                }
            else if (c <= 0x03 || c == 0x0D) {
		// ignore control characters
		}
	    else if (numChars < sizeof(cmdLine) - 1) {
		cmdLine[numChars++] = c;
                cmdLine[numChars] = 0;
		printf("char added\n");
		}
	    else {
		//Reply(sock, 501, "Command line too long");
		}
	}
    }
    //printf("Connection closed\n");
}
			
int startserver(int portno)
{
    int sockfd, newsockfd, clilen, optval;
    pthread_t thread;
    char buffer[256];
    struct sockaddr_in serv_addr, cli_addr;
    int n;
    int pid;
    sockfd = socket(AF_INET, SOCK_STREAM, 0);

    if (sockfd < 0) 
        error("ERROR opening socket");
    optval = 1;
    setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, 
	     (const void *)&optval , sizeof(int));
	     
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = INADDR_ANY;
    serv_addr.sin_port = htons(portno);
    if (bind(sockfd, (struct sockaddr *) &serv_addr,
              sizeof(serv_addr)) < 0) 
              error("ERROR on binding");
    listen(sockfd,5);
    clilen = sizeof(cli_addr);
    while(1) {
	newsockfd = accept(sockfd, 
                 (struct sockaddr *) &cli_addr, 
                 &clilen);
	if (newsockfd > 0) {
	    printf("Connected...\n");
	    dostuff(&newsockfd);
	    printf("disconnected\n");
	}
    }		  
    return 0; 
}
			
